#include <CoreFoundation/CoreFoundation.h>
#import <Foundation/Foundation.h>
#include <stdio.h>
#import <objc/runtime.h>
#import <UIKit/UIKit.h>

#import "KAIBattery.mm"

@interface UIApplication (Kai)
+(id)sharedApplication;
-(BOOL)launchApplicationWithIdentifier:(id)arg1 suspended:(BOOL)arg2;
@end

@interface CSAdjunctListView : UIView
@property (nonatomic, assign) BOOL hasKai;
@property (nonatomic, assign) NSInteger previousKaiCount;
-(UIStackView *)stackView;
-(void)setStackView:(UIStackView *)arg1;
-(void)KaiUpdate;
@end

@interface CSMainPageView : UIView
-(void)updateForPresentation:(id)arg1;
@end

@interface _CSSingleBatteryChargingView : UIView
@end

@interface NCNotificationListView : UIView
@end

BOOL setFrame = NO;
CGRect original = CGRectMake(0,0,0,0);
CGRect originalBattery;


%hook CSAdjunctListView
%property (nonatomic, assign) BOOL hasKai;
%property (nonatomic, assign) NSInteger previousKaiCount;

-(void)_layoutStackView {
	/*[KAIBattery sharedInstance].translatesAutoresizingMaskIntoConstraints = NO;
        [[KAIBattery sharedInstance].leftAnchor constraintEqualToAnchor:[KAIBattery sharedInstance].leftAnchor].active = YES;
        [[KAIBattery sharedInstance].topAnchor constraintEqualToAnchor:[KAIBattery sharedInstance].topAnchor].active = YES;
        [[KAIBattery sharedInstance].widthAnchor constraintEqualToConstant:UIScreen.mainScreen.bounds.size.width].active = YES;
        [[KAIBattery sharedInstance].heightAnchor constraintEqualToConstant:([KAIBattery sharedInstance].number * 85)].active = YES;*/

	NSLog(@"Kai: Laying out stack view");
	//%orig;

	[self KaiUpdate];

	%orig;
}

-(void)setStackView:(UIStackView *)arg1 {
	NSLog(@"Kai: Updating setting stack view");

	if(!self.hasKai) {
	//original = self.superview.superview.frame;
		KAIBattery *battery = [[KAIBattery alloc] initWithFrame:CGRectMake(0, 0, UIScreen.mainScreen.bounds.size.width, 0)];
		/*battery.translatesAutoresizingMaskIntoConstraints = YES;
        [battery.leftAnchor constraintEqualToAnchor:battery.leftAnchor].active = YES;
        [battery.topAnchor constraintEqualToAnchor:battery.topAnchor].active = YES;
        [battery.widthAnchor constraintEqualToConstant:UIScreen.mainScreen.bounds.size.width].active = YES;
        [battery.heightAnchor constraintEqualToConstant:(battery.number * 85)].active = YES;*/
		originalBattery = battery.frame;
		original = self.frame;
		setFrame = YES;
		self.previousKaiCount = 0;
		self.hasKai = YES;
		[[NSNotificationCenter defaultCenter] addObserver:self
			selector:@selector(KaiInfo)
			name:@"KaiInfoChanged"
			object:nil];
	[[KAIBattery sharedInstance] darkLightMode];
	}

	UIStackView *newView = arg1;

	if(![arg1.subviews containsObject:[KAIBattery sharedInstance]]) {
		//[newView addSubview:[KAIBattery sharedInstance]];
		[newView addArrangedSubview:[KAIBattery sharedInstance]];
	}/* else if(arg1==nil) {
		newView = (UIStackView *)[KAIBattery sharedInstance];
	}*/
	%orig(newView);
}

%new
-(void)KaiUpdate {
	[[KAIBattery sharedInstance] darkLightMode];
	/*KAIBattery *battery = [KAIBattery sharedInstance];
	battery.translatesAutoresizingMaskIntoConstraints = YES;
	battery.frame = CGRectMake(
		originalBattery.origin.x,
		originalBattery.origin.y,
		originalBattery.size.width,
		(battery.number * 85)
	);*/
}

%new
-(void)KaiInfo {
	NSLog(@"Kai: Updating Info");
	[[KAIBattery sharedInstance] updateBattery];
	[self KaiUpdate];
}
%end


%hook BCBatteryDevice

- (id)initWithIdentifier:(id)arg1 vendor:(long long)arg2 productIdentifier:(long long)arg3 parts:(unsigned long long)arg4 matchIdentifier:(id)arg5 {

	[self addObserver:self forKeyPath:@"name" options:NSKeyValueObservingOptionNew context:nil];
	[self addObserver:self forKeyPath:@"charging" options:NSKeyValueObservingOptionNew context:nil];
	[self addObserver:self forKeyPath:@"powerSourceState" options:NSKeyValueObservingOptionNew context:nil];
	[self addObserver:self forKeyPath:@"batterySaverModeActive" options:NSKeyValueObservingOptionNew context:nil];
	[self addObserver:self forKeyPath:@"percentCharge" options:NSKeyValueObservingOptionNew context:nil];

	//[self setValue:@"crash" forKeyPath:@"euhidehuud"];

	return %orig;
}

-(void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context{
	dispatch_async(dispatch_get_main_queue(), ^{
	[[NSNotificationCenter defaultCenter] postNotificationName:@"KaiInfoChanged" object:nil userInfo:nil];
	});
	
}
%end

%hook _CSSingleBatteryChargingView

-(void)initWithFrame:(CGRect)arg1 {
	%orig;
	[self removeFromSuperview];
}

-(CGFloat)desiredVisibilityDuration {
	return 0;
}

-(void)setBatteryVisible:(BOOL)arg1 {
	%orig(NO);
}

%end
